Bug 819884 - Process definition is lost in the Designer if a mistake is done when specifying passing of variable to and from service tasks
Process definition is lost in the Designer if a mistake is done when specifyi...
Status: VERIFIED
Product: JBoss Enterprise BRMS Platform 5
Classification: JBoss
Component: jBPM 5 (Show other bugs)
BRMS 5.3.0.GA
Unspecified Unspecified
unspecified Severity urgent
: ER7
: BRMS 5.3.0.GA
Assigned To: Tihomir Surdilovic
Sona Mala
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-08 09:18 EDT by Jiri Svitak
Modified: 2015-06-01 21:36 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
atangrin: needinfo+


Attachments (Terms of Use)

  None (edit)
Description Jiri Svitak 2012-05-08 09:18:54 EDT
When you specify something badly in a service task variable mapping, you get no warning and after saving your business process, your business process definition is lost. You should not lose anything from your process definition, even if there is a mistake. User should be notified about existing problems and the process definition should never disappear from the Designer canvas.

As far as I can say, this bug makes working with service tasks, one of the fundamental parts of the jBPM, very painful.
Comment 1 Tihomir Surdilovic 2012-05-09 19:40:48 EDT
Added additional checks in order to make sure you cannot save a process which has issues with data assignments (or any other types of errors, like missing process var etc...). Will add in the future ability to see these errors during visual validation, but this will take some time, probably longer than development cycle for BRMS 5.3. Hope ability to not save the process but not loose your process model on canvas will be sufficient for now.

Fixes are in the Designer master and 2.2.x branches.
Comment 2 Ryan Zhang 2012-05-10 23:19:32 EDT
yep, I saw this is fixed in https://github.com/tsurdilo/process-designer/commit/241524f637dac9726cbc31b8ccb177fc7ae88c23 which is post block cut off date.

But I need to wait the block flag set property before doing ER7.

Assign to Anne to set the flag correctly.
Comment 3 Ryan Zhang 2012-05-10 23:32:24 EDT
It has  actually fixed in project. Change status to needinfo instead of Assignee.
Comment 5 Ryan Zhang 2012-05-14 04:16:57 EDT
The fixed for this issue should be included in ER7. Please do verification on it.
Comment 7 Sona Mala 2012-05-24 06:37:16 EDT
Please, can you write me steps to reproduce this issue?

I created some BPMN2 process (start->My Task (Integer p1,Integer p1)->End). I set some variable f:Integer. I cannot set mapping of variable f to parameter p1. Every time I set this mapping in "Editor for DataAssigment". I cannot find it when I re-open this editor.

I verify that validation must be ok if you want to save process.
Comment 8 Jiri Svitak 2012-05-24 16:17:38 EDT
As far as I can remember, I forgot to fill process variables before setting up variable mapping. I have tried to use nondeclared process variables. Also try using the same variable name as the name of the first or second service task parameter, that caused problems too.

Perhaps I forgot to specify process variable and at the same time I mapped accidentally input parameter to output parameter with the same name and after the save it caused circular dependency in bpmn xml, so it crashed and process definition was corrupted and lost. I was told to use additional naming convention for parameters - to add string 'Input' and 'Output' at the end of the input and output parameters respectively to distinguish parameter names. Since then no problems occured.
Comment 9 Sona Mala 2012-05-28 06:32:49 EDT
ER8 ... for nonexist variable and circular dependency get same results.
 
Steps:
1. create simple process with one service task (2 inputs, 1 output)
2. set parameter mapping (nonexist variable | circular dependency)
3. validate process
4. save process

Results:
In spite of validation is ok (alert: "There are no validation errors."), I am not able to save process (Alert: "Validate your process before saving, and view server logs to see error details."). In server.log is ERROR [org.jbpm.designer.web.profile.impl.JbpmProfileImpl] (http-127.0.0.1-8080-16) 
java.lang.NullPointerException

I am not able to find out what is wrong.
Comment 10 Sona Mala 2012-05-29 05:21:43 EDT
I have looked on this issue (comment #9) and it is different problem. I have created new bz https://bugzilla.redhat.com/show_bug.cgi?id=825977

Note You need to log in before you can comment on or make changes to this bug.